﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace Aditivos
{
    public partial class Component : System.Web.UI.Page
    {
        DataTable Dt;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Page.Title = "Aditivos";
                Cargar_valoraciones_aditivo();
                Carga_Registros();
            }
            else
            {
            }
        }

        //Carga los registros de la grid
        private void Carga_Registros()
        {
            Models.ClsAditivo ObjAditivo = new Models.ClsAditivo();
            Dt = ObjAditivo.cargar_componentes(this.txtnombre.Text.Trim(),this.CmbValoracion.SelectedValue);
            Session["DtAditivo"] = Dt;
            Carga_Grid();
        }
        //Carga y ordena los registros de la grid según criterios
        private void Carga_Grid()
        {
            String sOrden="";
            try {
                Dt = (DataTable)Session["DtAditivo"];
                DataView DtView = new DataView(Dt);
                //Ordenar la grid en función del link clicado
                switch ((String) Session["ColumnaO"])
                    {
                    case "idComponente":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["idComponente"];
                        break;
                    case "Nombre":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["Nombre"];
                        break;
                    case "valoracion":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["valoracion"];
                        break;
                }
                DtView.Sort = sOrden;
                DtAditivos.DataSource = DtView;
                DtAditivos.DataBind();
            }
            catch (InvalidCastException e) {
            }
        }

        protected void DtAditivos_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            DtAditivos.EditIndex = -1;
            DtAditivos.PageIndex = e.NewPageIndex;
            Carga_Grid();
        }

        protected void DtAditivos_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            //Según el evento de la grid
            switch (e.CommandName)
            {
                case "Sort":
                    switch ((String)e.CommandArgument)
                    {
                        case "Codigo":
                            Session["ColumnaO"] = "idComponente";
                            if ((String)Session["idComponente"] == "ASC")
                            {
                                Session["idComponente"] = "DESC";
                            }
                            else
                            {
                                Session["idComponente"] = "ASC";
                            }
                            break;
                        case "Nombre":
                            Session["ColumnaO"] = "Nombre";
                            if ((String)Session["Nombre"] == "ASC")
                            {
                                Session["Nombre"] = "DESC";
                            }
                            else
                            {
                                Session["Nombre"] = "ASC";
                            }
                            break;
                        case "Valoracion":
                            Session["ColumnaO"] = "valoracion";
                            if ((String)Session["valoracion"] == "ASC")
                            {
                                Session["valoracion"] = "DESC";
                            }
                            else
                            {
                                Session["valoracion"] = "ASC";
                            }

                            break;
                    }
                    break;

                case "Select":
                    break;
            }
        }

        private void Cargar_valoraciones_aditivo()
        {
            DataTable DtTipo = new DataTable();
            ListItem Item = new ListItem();
            Item.Value = "";
            Item.Text = "";
            Models.ClsAditivo ObjAditivo = new Models.ClsAditivo();
            DtTipo = ObjAditivo.cargar_valoraciones_aditivo();
            this.CmbValoracion.DataSource = DtTipo;
            this.CmbValoracion.DataTextField = "Valoraciont";
            this.CmbValoracion.DataValueField = "Valoraciont";
            this.CmbValoracion.DataBind();
            this.CmbValoracion.Items.Insert(0, Item);
            this.CmbValoracion.SelectedValue = "";
        }


        protected void DtAditivos_Sorting(object sender, GridViewSortEventArgs e)
        {
            Carga_Grid();
        }

        protected void DtAditivos_SelectedIndexChanging(object sender, GridViewSelectEventArgs e)
        {
            String sUrl, sAditivo;
            Label csAditivo = (Label)(DtAditivos.Rows[e.NewSelectedIndex].FindControl("lblComponente"));
            sAditivo = csAditivo.Text;
            sUrl = "FrmCompDetalle.aspx?Aditivo=" + sAditivo.Trim();
            Response.Redirect(sUrl);
        }

        protected void DtAditivos_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void BtnBuscar_Click(object sender, EventArgs e)
        {
            Carga_Registros();
        }
    }
}