﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace Aditivos
{
    public partial class Items : System.Web.UI.Page
    {
        DataTable Dt,DtCategoria,DtAditivo;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Page.Title = "Buscar Articulos";
                Carga_Categorias();
                Cargar_tipos_aditivo();
                //Carga_Categorias();
                Cargar_Articulos();

            }
            else
            {
            }
        }
        //Carga los registros de la grid
        //Carga los componentes en el listItem
        private void Carga_Componentes()
        {
            ListItem Item = new ListItem();
            Item.Value = "";
            Item.Text = "";
            Models.ClsAditivo ObjAditivo = new Models.ClsAditivo();
            Dt = ObjAditivo.cargar_componentes(CmbAditivo.SelectedValue.ToString());
            this.CmbComponente.DataSource = Dt;
            this.CmbComponente.DataTextField = "Nombre";
            this.CmbComponente.DataValueField = "idComponente";
            this.CmbComponente.DataBind();
            this.CmbComponente.Items.Insert(0, Item);
            this.CmbComponente.SelectedValue = "";

        }
        //Carga el combo de categorias
        private void Carga_Categorias()
        {
            ListItem Item = new ListItem();
            Item.Value = "";
            Item.Text = "";
            Models.ClsCategoria ObjCategoria = new Models.ClsCategoria();
            DtCategoria = ObjCategoria.cargar_categorias();
            this.CmbTipo.DataSource = DtCategoria;
            this.CmbTipo.DataTextField = "descripcion";
            this.CmbTipo.DataValueField = "idCategoria";
            this.CmbTipo.DataBind();
            this.CmbTipo.Items.Insert(0, Item);
            this.CmbTipo.SelectedValue = "";
        }
        //Carga tipo de articulos
        private void Cargar_tipos_aditivo()
        {
            ListItem Item = new ListItem();
            Item.Value = "";
            Item.Text = "";
            Models.ClsAditivo ObjAditivo = new Models.ClsAditivo();
            DtAditivo = ObjAditivo.cargar_tipos_aditivo();
            this.CmbAditivo.DataSource = DtAditivo;
            this.CmbAditivo.DataTextField = "Tipo";
            this.CmbAditivo.DataValueField = "Tipo";
            this.CmbAditivo.DataBind();
            CmbAditivo.Items.Insert(0, Item);
            this.CmbAditivo.SelectedValue = "";
        }

        //Carga tipo de articulos
        private void Cargar_Articulos()
        {
     
            Models.ClsArticulo ObjArticulos = new Models.ClsArticulo();
            Dt = ObjArticulos.cargar_articulos(this.CmbTipo.SelectedValue,this.RdContiene.SelectedValue,this.CmbComponente.SelectedValue);
            Session["DtArticulo"] = Dt;
            Carga_Grid();
        }

        //Carga y ordena los registros de la grid según criterios
        private void Carga_Grid()
        {
            String sOrden = "";
            try
            {
                Dt = (DataTable)Session["DtArticulo"];
                DataView DtView = new DataView(Dt);
                //Ordenar la grid en función del link clicado
                switch ((String)Session["ColumnaO"])
                {
                    case "id":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["id"];
                        break;
                    case "nombre":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["nombre"];
                        break;
                    case "Marca":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["Marca"];
                        break;
                    case "Suma":
                        sOrden = (String)Session["ColumnaO"] + " " + (String)Session["Suma"];
                        break;
                }
                DtView.Sort = sOrden;
                DtArticulos.DataSource = DtView;
                DtArticulos.DataBind();
                UpdatePanel2.Update();
            }
            catch (InvalidCastException e)
            {
            }
        }
        protected void DtArticulos_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void DtArticulos_Sorting(object sender, GridViewSortEventArgs e)
        {
            Carga_Grid();

        }

        protected void DtArticulos_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            DtArticulos.EditIndex = -1;
            DtArticulos.PageIndex = e.NewPageIndex;
            Carga_Grid();
        }

        protected void DtArticulos_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            //Según el evento de la grid
            switch (e.CommandName)
            {
                case "Sort":
                    switch ((String)e.CommandArgument)
                    {
                        case "Codigo":
                            Session["ColumnaO"] = "id";
                            if ((String)Session["id"] == "ASC")
                            {
                                Session["id"] = "DESC";
                            }
                            else
                            {
                                Session["id"] = "ASC";
                            }
                            break;
                        case "Nombre":
                            Session["ColumnaO"] = "nombre";
                            if ((String)Session["nombre"] == "ASC")
                            {
                                Session["nombre"] = "DESC";
                            }
                            else
                            {
                                Session["nombre"] = "ASC";
                            }
                            break;
                        case "Marca":
                            Session["ColumnaO"] = "Marca";
                            if ((String)Session["Marca"] == "ASC")
                            {
                                Session["Marca"] = "DESC";
                            }
                            else
                            {
                                Session["Marca"] = "ASC";
                            }

                            break;
                        case "Suma":
                            Session["ColumnaO"] = "Suma";
                            if ((String)Session["Suma"] == "ASC")
                            {
                                Session["Suma"] = "DESC";
                            }
                            else
                            {
                                Session["Suma"] = "ASC";
                            }

                            break;
                    }
                    break;

                case "Select":
                    break;
            }
        }

        protected void CmbAditivo_SelectedIndexChanged(object sender, EventArgs e)
        {
            Carga_Componentes();
        }

        protected void DtArticulos_SelectedIndexChanging(object sender, GridViewSelectEventArgs e)
        {
            String sUrl, sArticulo,sValoracion;
            Label csArticulo = (Label)(DtArticulos.Rows[e.NewSelectedIndex].FindControl("lblComponente"));
            sArticulo = csArticulo.Text;
            Label csPuntuacion = (Label)(DtArticulos.Rows[e.NewSelectedIndex].FindControl("lblValoracion1"));
            sValoracion = csPuntuacion.Text;
            Label csNombre = (Label)(DtArticulos.Rows[e.NewSelectedIndex].FindControl("lblNombre1"));
            Session["Nombre"] = csNombre.Text;
            sUrl = "FrmArticulo.aspx?Articulo=" + sArticulo.Trim() + "&Valoracion=" + sValoracion; 
            Response.Redirect(sUrl);
        }   

        protected void BtnBuscar_Click(object sender, EventArgs e)
        {
            Cargar_Articulos();
        }



    protected void CmbTipo_SelectedIndexChanged(object sender, EventArgs e)
        {
            
        }
    }
}